Index: src/data/flexifile.c
===================================================================
RCS file: src/data/flexifile.c
diff -N src/data/flexifile.c
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ src/data/flexifile.c	13 Jul 2006 05:27:04 -0000
@@ -0,0 +1,423 @@
+/* PSPP - computes sample statistics.
+
+   Copyright (C) 2006 Free Software Foundation, Inc.
+   Written by John Darrington <john@darrington.wattle.id.au>
+
+   This program is free software; you can redistribute it and/or
+   modify it under the terms of the GNU General Public License as
+   published by the Free Software Foundation; either version 2 of the
+   License, or (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful, but
+   WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software
+   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+   02110-1301, USA. */
+
+#include <config.h>
+#include <xalloc.h>
+#include <assert.h>
+#include "flexifile.h"
+#include "casefile.h"
+#include "casefile-private.h"
+#include "case.h"
+
+
+struct class_flexifile
+{
+  struct class_casefile parent;
+  bool initialised;
+  unsigned long stamp;
+
+  bool (*get_case) (const struct flexifile *, unsigned long, struct ccase *);
+
+  bool (*insert_case) (struct flexifile *, struct ccase *, int );
+  bool (*delete_cases) (struct flexifile *, int, int );
+
+  bool (*resize) (struct flexifile *, int, int );
+};
+
+static struct class_flexifile class;
+
+#define CLASS_FLEXIFILE(K)  ((struct class_flexifile *) K)
+#define CONST_CLASS_FLEXIFILE(K) ((const struct class_flexifile *) K)
+
+
+/* A flexifile. */
+struct flexifile
+{
+  struct casefile cf;		/* Parent */
+
+  size_t value_cnt;		/* Case size in `union value's. */
+  unsigned long case_cnt;	/* Number of cases stored. */
+
+
+  /* Memory storage. */
+  struct ccase *cases;		/* Pointer to array of cases. */
+  unsigned long capacity;       /* size of array in cases */
+};
+
+struct class_flexifilereader 
+{
+  struct class_casereader parent ;
+
+  bool initialised;
+  unsigned long stamp;
+};
+
+static struct class_flexifilereader class_reader;
+
+/* For reading out the cases in a flexifile. */
+struct flexifilereader
+{
+  struct casereader cr;		/* Parent */
+
+  unsigned long case_idx;	/* Case number of current case. */
+  bool destructive;		/* Is this a destructive reader? */
+};
+
+
+
+#define CHUNK_SIZE 10
+
+static bool 
+impl_get_case(const struct flexifile *ff, unsigned long casenum, 
+	      struct ccase *);
+static bool
+impl_insert_case (struct flexifile *ff, struct ccase *c, int posn);
+
+static bool 
+impl_delete_cases (struct flexifile *ff, int n_cases, int first);
+
+static bool 
+impl_resize (struct flexifile *ff, int n_values, int posn);
+
+
+/* Gets a case, for which writing may not be safe */
+bool 
+flexifile_get_case(const struct flexifile *ff, unsigned long casenum, 
+		   struct ccase *c)
+{
+  const struct class_flexifile *class = 
+    CONST_CLASS_FLEXIFILE (CONST_CASEFILE(ff)->class) ;
+
+  return class->get_case(ff, casenum, c);
+}
+
+
+/* Insert N_VALUES before POSN.
+   If N_VALUES is negative, then deleted -N_VALUES instead
+*/
+bool
+flexifile_resize (struct flexifile *ff, int n_values, int posn)
+{
+  const struct class_flexifile *class = 
+    CONST_CLASS_FLEXIFILE (CONST_CASEFILE(ff)->class) ;
+
+  return class->resize(ff, n_values, posn);
+}
+
+
+
+bool
+flexifile_insert_case (struct flexifile *ff, struct ccase *c, int posn)
+{
+  const struct class_flexifile *class = 
+    CONST_CLASS_FLEXIFILE (CONST_CASEFILE(ff)->class) ;
+
+  return class->insert_case(ff, c, posn);
+}
+
+
+bool
+flexifile_delete_cases (struct flexifile *ff, int n_cases, int first)
+{
+  const struct class_flexifile *class = 
+    CONST_CLASS_FLEXIFILE (CONST_CASEFILE(ff)->class) ;
+
+  return class->delete_cases (ff, n_cases, first);
+}
+
+
+static unsigned long 
+flexifile_get_case_cnt (const struct casefile *cf)
+{
+  return FLEXIFILE(cf)->case_cnt;
+}
+
+static size_t
+flexifile_get_value_cnt (const struct casefile *cf)
+{
+  return FLEXIFILE(cf)->value_cnt;
+}
+
+
+static void
+flexifile_destroy (struct casefile *cf)
+{
+  int i ; 
+  for ( i = 0 ; i < FLEXIFILE(cf)->case_cnt; ++i ) 
+    case_destroy( &FLEXIFILE(cf)->cases[i]);
+
+  free(FLEXIFILE(cf)->cases);
+}
+
+static void
+grow(struct flexifile *ff) 
+{
+  ff->capacity += CHUNK_SIZE;
+  ff->cases = xrealloc(ff->cases, ff->capacity * sizeof ( *ff->cases) );
+}
+
+static bool
+flexifile_append (struct casefile *cf, const struct ccase *c)
+{
+  struct flexifile *ff =  FLEXIFILE(cf);
+
+  if (ff->case_cnt >= ff->capacity)
+    grow(ff);
+
+  case_clone (&ff->cases[ff->case_cnt++], c);
+
+  return true;
+}
+
+/* Reads a copy of the next case from READER into C.
+   Caller is responsible for destroying C.
+   Returns true if successful, false at end of file. */
+static bool
+flexifilereader_read (struct casereader *cr, struct ccase *c)
+{
+  struct flexifilereader *ffr = FLEXIFILEREADER(cr);
+  struct flexifile *ff = FLEXIFILE(casereader_get_casefile(cr));
+
+  if ( ffr->case_idx >= ff->case_cnt) 
+    return false;
+
+  case_clone (c, &ff->cases[ffr->case_idx++]);
+
+  return true;
+}
+
+
+static bool
+flexifilereader_read_xfer (struct casereader *cr, struct ccase *c)
+{
+  struct flexifile *ff;
+  struct flexifilereader *ffr = FLEXIFILEREADER (cr);
+  assert (ffr);
+
+  ff = FLEXIFILE(casereader_get_casefile(cr));
+
+  if (ffr->destructive == 0
+      || ffr->case_idx >= ff->case_cnt )
+    {
+      return flexifilereader_read (cr, c);
+    }
+  else
+    {
+      struct ccase *read_case = &ff->cases[ffr->case_idx];
+
+      case_move (c, read_case);
+      ffr->case_idx++;
+      return true;
+    }
+}
+
+static void
+flexifilereader_destroy(struct casereader *r)
+{
+  free(r);
+}
+
+static struct casereader * 
+flexifile_get_reader (const struct casefile *cf_)
+{
+  struct casefile *cf = (struct casefile *) cf_;
+  struct flexifilereader *ffr = xzalloc (sizeof *ffr);
+  struct casereader *reader = (struct casereader *) ffr;
+
+  if ( ! class_reader.initialised ) 
+    {
+      class_reader.stamp = random ();
+      class_reader.initialised = true;
+
+      class_reader.parent.read = flexifilereader_read;
+      class_reader.parent.read_xfer = flexifilereader_read_xfer;
+      class_reader.parent.destroy = flexifilereader_destroy;
+    }
+
+  casereader_register (cf, reader, CLASS_CASEREADER(&class_reader));
+
+  return reader;
+}
+
+static bool
+flexifile_in_core(const struct casefile *cf UNUSED)
+{
+  /* Always in memory */
+  return true;
+}
+
+struct casefile *
+flexifile_create (size_t value_cnt)
+{
+  struct flexifile *ff = xzalloc (sizeof *ff);
+  struct casefile *cf = (struct casefile *) ff;
+
+  if ( ! class.initialised ) 
+    {
+      class.stamp = random ();
+      class.initialised = true;
+
+      class.parent.get_case_cnt = flexifile_get_case_cnt;
+      class.parent.destroy = flexifile_destroy;
+      class.parent.append = flexifile_append;
+      class.parent.get_reader = flexifile_get_reader;
+      class.parent.in_core = flexifile_in_core;
+      class.parent.get_value_cnt = flexifile_get_value_cnt;
+
+      class.get_case = impl_get_case ;
+      class.insert_case = impl_insert_case ;
+      class.delete_cases = impl_delete_cases;
+      class.resize = impl_resize;
+    }
+
+  casefile_register (cf, (struct class_casefile *) &class);
+
+  ff->value_cnt = value_cnt;
+ 
+  ff->cases = xzalloc(sizeof (struct ccase *) * CHUNK_SIZE);
+  ff->capacity = CHUNK_SIZE;
+ 
+  return cf;
+}
+
+/* Casts */
+
+struct flexifilereader *
+flexifilereader_cast(const struct casereader *cr)
+{
+  struct class_flexifilereader *kr = 
+    (struct class_flexifilereader *) cr->class;
+  
+  assert ( kr->stamp == class_reader.stamp );
+  return (struct flexifilereader *) cr;
+}
+
+struct flexifile *
+flexifile_cast(const struct casefile *cf)
+{
+  struct class_flexifile *kf = (struct class_flexifile *) cf->class;
+  
+  assert ( kf->stamp == class.stamp );
+  return (struct flexifile *) cf;
+}
+
+
+
+
+/* Implementations of class methods */
+
+static bool 
+impl_get_case(const struct flexifile *ff, unsigned long casenum, 
+	      struct ccase *c)
+{
+  if ( casenum >= ff->case_cnt) 
+    return false;
+
+  case_clone (c, &ff->cases[casenum]);
+  
+  return true;
+}
+
+#if DEBUGGING
+static void
+dumpcasedata(struct ccase *c)
+{
+  int i;
+  for ( i = 0 ; i < c->case_data->value_cnt * MAX_SHORT_STRING; ++i ) 
+    putchar(c->case_data->values->s[i]);
+  putchar('\n');
+}
+#endif
+
+static bool 
+impl_resize (struct flexifile *ff, int n_values, int posn)
+{
+  int i;
+  for( i = 0 ; i < ff->case_cnt ; ++i ) 
+    {
+      struct ccase c;
+      case_create (&c, ff->value_cnt + n_values);
+
+      case_copy (&c, 0, &ff->cases[i], 0, posn);
+      if ( n_values > 0 ) 
+	memset (case_data_rw(&c, posn), ' ', n_values * MAX_SHORT_STRING) ;
+      case_copy (&c, posn + n_values, 
+		 &ff->cases[i], posn, ff->value_cnt - posn);
+
+      case_destroy (&ff->cases[i]);
+      ff->cases[i] = c;
+    }
+
+  ff->value_cnt += n_values;
+
+  return true;
+}
+
+static bool
+impl_insert_case (struct flexifile *ff, struct ccase *c, int posn)
+{
+  int i;
+  struct ccase blank;
+  
+  assert (ff);
+
+  if ( posn > ff->case_cnt )
+    return false;
+
+  if ( posn >= ff->capacity ) 
+    grow(ff);
+
+  case_create(&blank, ff->value_cnt);
+
+  flexifile_append(CASEFILE(ff), &blank);
+
+  case_destroy(&blank);
+
+  /* Shift the existing cases down one */
+  for ( i = ff->case_cnt ; i > posn; --i)
+      case_move(&ff->cases[i], &ff->cases[i-1]);
+
+  case_clone (&ff->cases[posn], c);
+
+  return true;
+}
+
+
+static bool 
+impl_delete_cases (struct flexifile *ff, int n_cases, int first)
+{
+  int i;
+
+  if ( ff->case_cnt < first + n_cases ) 
+    return false;
+
+  for ( i = first ; i < first + n_cases; ++i ) 
+    case_destroy (&ff->cases[i]);
+  
+  /* Shift the cases up by N_CASES */
+  for ( i = first; i < ff->case_cnt - n_cases; ++i ) 
+    {
+      case_move (&ff->cases[i], &ff->cases[i+ n_cases]);
+    }
+
+  ff->case_cnt -= n_cases;
+  
+  return true;
+}
Index: src/data/flexifile.h
===================================================================
RCS file: src/data/flexifile.h
diff -N src/data/flexifile.h
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ src/data/flexifile.h	13 Jul 2006 05:27:04 -0000
@@ -0,0 +1,52 @@
+/* PSPP - computes sample statistics.
+   Copyright (C) 2006 Free Software Foundation, Inc.
+   Written by John Darrington <john@darrington.wattle.id.au>
+
+   This program is free software; you can redistribute it and/or
+   modify it under the terms of the GNU General Public License as
+   published by the Free Software Foundation; either version 2 of the
+   License, or (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful, but
+   WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software
+   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+   02110-1301, USA. */
+
+#ifndef FLEXIFILE_H
+#define FLEXIFILE_H
+
+#include <config.h>
+#include <stdbool.h>
+#include <stdlib.h>
+
+struct ccase;
+struct casefile;
+struct casereader;
+struct flexifile;
+struct flexifilereader;
+
+/* Casts */
+struct flexifile * flexifile_cast(const struct casefile *cf);
+struct flexifilereader *flexifilereader_cast(const struct casereader *cr);
+
+
+#define FLEXIFILE(CF) flexifile_cast(CF)
+#define FLEXIFILEREADER(CR) flexifilereader_cast(CR)
+
+struct casefile *flexifile_create (size_t value_cnt);
+
+bool flexifile_get_case(const struct flexifile *ff, unsigned long casenum, 
+			struct ccase *const c);
+
+bool flexifile_resize (struct flexifile *ff, int n_values, int posn);
+
+bool flexifile_insert_case (struct flexifile *ff, struct ccase *c, int posn);
+bool flexifile_delete_cases (struct flexifile *ff, int n_cases, int first);
+
+
+#endif
Index: src/data/procedure.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/data/procedure.c,v
retrieving revision 1.9
diff -u -p -r1.9 procedure.c
--- src/data/procedure.c	7 May 2006 05:46:26 -0000	1.9
+++ src/data/procedure.c	13 Jul 2006 05:27:05 -0000
@@ -28,6 +28,7 @@
 #include <data/case-sink.h>
 #include <data/case.h>
 #include <data/casefile.h>
+#include <data/fastfile.h>
 #include <data/dictionary.h>
 #include <data/file-handle-def.h>
 #include <data/procedure.h>
@@ -168,7 +169,7 @@ multipass_procedure (bool (*proc_func) (
   struct multipass_aux_data aux_data;
   bool ok;
 
-  aux_data.casefile = casefile_create (dict_get_next_value_idx (default_dict));
+  aux_data.casefile = fastfile_create (dict_get_next_value_idx (default_dict));
   aux_data.proc_func = proc_func;
   aux_data.aux = aux;
 
@@ -617,7 +618,7 @@ multipass_split_case_func (const struct 
         ok = multipass_split_output (aux);
 
       /* Start a new casefile. */
-      aux->casefile = casefile_create (dict_get_next_value_idx (default_dict));
+      aux->casefile = fastfile_create (dict_get_next_value_idx (default_dict));
     }
 
   return casefile_append (aux->casefile, c) && ok;
Index: src/data/scratch-writer.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/data/scratch-writer.c,v
retrieving revision 1.2
diff -u -p -r1.2 scratch-writer.c
--- src/data/scratch-writer.c	6 May 2006 22:37:30 -0000	1.2
+++ src/data/scratch-writer.c	13 Jul 2006 05:27:05 -0000
@@ -22,6 +22,7 @@
 #include <stdlib.h>
 #include "case.h"
 #include "casefile.h"
+#include "fastfile.h"
 #include "dictionary.h"
 #include "file-handle-def.h"
 #include "scratch-handle.h"
@@ -72,7 +73,7 @@ scratch_writer_open (struct file_handle 
   /* Create new contents. */
   sh = xmalloc (sizeof *sh);
   sh->dictionary = scratch_dict;
-  sh->casefile = casefile_create (dict_get_next_value_idx (sh->dictionary));
+  sh->casefile = fastfile_create (dict_get_next_value_idx (sh->dictionary));
 
   /* Create writer. */
   writer = xmalloc (sizeof *writer);
@@ -115,7 +116,6 @@ scratch_writer_close (struct scratch_wri
 {
   struct casefile *cf = writer->handle->casefile;
   bool ok = casefile_error (cf);
-  casefile_mode_reader (cf);
   fh_close (writer->fh, "scratch file", "we");
   free (writer);
   return ok;
Index: src/data/storage-stream.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/data/storage-stream.c,v
retrieving revision 1.5
diff -u -p -r1.5 storage-stream.c
--- src/data/storage-stream.c	7 Jul 2006 02:10:08 -0000	1.5
+++ src/data/storage-stream.c	13 Jul 2006 05:27:05 -0000
@@ -28,6 +28,7 @@
 #include <data/case-source.h>
 #include <data/case.h>
 #include <data/casefile.h> 
+#include <data/fastfile.h> 
 
 #include "xalloc.h"
 
@@ -46,7 +47,7 @@ storage_sink_open (struct case_sink *sin
   struct storage_stream_info *info;
 
   sink->aux = info = xmalloc (sizeof *info);
-  info->casefile = casefile_create (sink->value_cnt);
+  info->casefile = fastfile_create (sink->value_cnt);
 }
 
 /* Destroys storage stream represented by INFO. */
Index: src/language/data-io/get.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/data-io/get.c,v
retrieving revision 1.15
diff -u -p -r1.15 get.c
--- src/language/data-io/get.c	8 Jul 2006 03:05:51 -0000	1.15
+++ src/language/data-io/get.c	13 Jul 2006 05:27:06 -0000
@@ -27,6 +27,7 @@
 #include <data/case-source.h>
 #include <data/case.h>
 #include <data/casefile.h>
+#include <data/fastfile.h>
 #include <data/dictionary.h>
 #include <data/por-file-writer.h>
 #include <data/procedure.h>
@@ -1126,7 +1127,7 @@ cmd_match_files (void)
     discard_variables ();
 
   dict_compact_values (mtf.dict);
-  mtf.output = casefile_create (dict_get_next_value_idx (mtf.dict));
+  mtf.output = fastfile_create (dict_get_next_value_idx (mtf.dict));
   mtf.seq_nums = xcalloc (dict_get_var_cnt (mtf.dict), sizeof *mtf.seq_nums);
   case_create (&mtf.mtf_case, dict_get_next_value_idx (mtf.dict));
 
Index: src/language/tests/casefile-test.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/tests/casefile-test.c,v
retrieving revision 1.3
diff -u -p -r1.3 casefile-test.c
--- src/language/tests/casefile-test.c	7 Jun 2006 01:48:47 -0000	1.3
+++ src/language/tests/casefile-test.c	13 Jul 2006 05:27:06 -0000
@@ -19,6 +19,8 @@
 
 #include <config.h>
 #include <data/casefile.h>
+#include <data/fastfile.h>
+
 #include <data/case.h>
 
 #include <gsl/gsl_randist.h>
@@ -88,7 +90,7 @@ test_casefile (int pattern, size_t value
   size_t i, j;
 
   rng = gsl_rng_alloc (gsl_rng_mt19937);
-  cf = casefile_create (value_cnt);
+  cf = fastfile_create (value_cnt);
   if (pattern == 5)
     casefile_to_disk (cf);
   for (i = 0; i < case_cnt; i++)
@@ -136,24 +138,6 @@ test_casefile (int pattern, size_t value
     casereader_destroy (r1);
   if (pattern != 2)
     casereader_destroy (r2);
-  if (pattern > 3) 
-    {
-      int *order;
-      r1 = casefile_get_random_reader (cf);
-      order = xmalloc (sizeof *order * case_cnt);
-      for (i = 0; i < case_cnt; i++)
-        order[i] = i;
-      if (case_cnt > 0)
-        gsl_ran_shuffle (rng, order, case_cnt, sizeof *order);
-      for (i = 0; i < case_cnt; i++)
-        {
-          int case_idx = order[i];
-          casereader_seek (r1, case_idx);
-          read_and_verify_random_case (cf, r1, case_idx);
-        }
-      casereader_destroy (r1);
-      free (order);
-    }
   if (pattern > 2) 
     {
       r1 = casefile_get_destructive_reader (cf);
Index: src/math/sort.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/math/sort.c,v
retrieving revision 1.11
diff -u -p -r1.11 sort.c
--- src/math/sort.c	8 Jul 2006 03:05:52 -0000	1.11
+++ src/math/sort.c	13 Jul 2006 05:27:07 -0000
@@ -30,6 +30,7 @@
 #include <data/case-source.h>
 #include <data/case.h>
 #include <data/casefile.h>
+#include <data/fastfile.h>
 #include <data/procedure.h>
 #include <data/settings.h>
 #include <data/variable.h>
@@ -162,7 +163,7 @@ do_internal_sort (struct casereader *rea
     return NULL;
       
   case_cnt = casefile_get_case_cnt (src);
-  dst = casefile_create (casefile_get_value_cnt (src));
+  dst = fastfile_create (casefile_get_value_cnt (src));
   if (case_cnt != 0) 
     {
       struct indexed_case *cases = nmalloc (sizeof *cases, case_cnt);
@@ -508,7 +509,7 @@ start_run (struct initial_run_state *irs
 {
   irs->run++;
   irs->case_cnt = 0;
-  irs->casefile = casefile_create (irs->xsrt->value_cnt);
+  irs->casefile = fastfile_create (irs->xsrt->value_cnt);
   casefile_to_disk (irs->casefile);
   case_nullify (&irs->last_output); 
 }
@@ -673,7 +674,7 @@ merge_once (struct external_sort *xsrt,
     }
 
   /* Create output file. */
-  output = casefile_create (xsrt->value_cnt);
+  output = fastfile_create (xsrt->value_cnt);
   casefile_to_disk (output);
 
   /* Merge. */
Index: src/ui/gui/menu-actions.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/ui/gui/menu-actions.c,v
retrieving revision 1.12
diff -u -p -r1.12 menu-actions.c
--- src/ui/gui/menu-actions.c	13 Jul 2006 04:00:06 -0000	1.12
+++ src/ui/gui/menu-actions.c	13 Jul 2006 05:27:08 -0000
@@ -196,9 +196,7 @@ load_system_file(const gchar *file_name)
 	  g_warning("Cannot write case to casefile\n");
 	  break;
 	}
-
       case_destroy(&c);
-
     }
   
   sfm_close_reader(reader);      
@@ -345,57 +343,38 @@ on_quit1_activate                      (
 
 
 void
-on_cut1_activate                       (GtkMenuItem     *menuitem,
-                                        gpointer         user_data)
-{
-
-}
-
-
-void
-on_copy1_activate                      (GtkMenuItem     *menuitem,
-                                        gpointer         user_data)
-{
-
-}
-
-
-void
-on_paste1_activate                     (GtkMenuItem     *menuitem,
+on_clear_activate                    (GtkMenuItem     *menuitem,
                                         gpointer         user_data)
 {
+  GtkNotebook *notebook = GTK_NOTEBOOK(get_widget_assert(xml, "notebook1"));
+  gint page = -1;
 
-}
+  page = gtk_notebook_get_current_page(notebook);
 
-/* Fill a case with SYSMIS for numeric and whitespace for string
-   variables respectively */ 
-static gboolean 
-blank_case(struct ccase *cc, gpointer _dict)
+  switch (page) 
 {
-  gint i;
-  PsppireDict *dict = _dict;
-
-  for(i = 0 ; i < psppire_dict_get_var_cnt(dict); ++i ) 
+    case PAGE_DATA_SHEET:
     {
-      union value *val ;
-
-      const struct PsppireVariable *var = psppire_dict_get_variable(dict, i);
-      
-      gint idx = psppire_variable_get_fv(var);
-
-      val = case_data_rw(cc, idx) ;
+	GtkSheet *data_sheet = GTK_SHEET(get_widget_assert(xml, "data_sheet"));
+	PsppireDataStore *data_store = 
+	  PSPPIRE_DATA_STORE(gtk_sheet_get_model(data_sheet));
 
-      if ( psppire_variable_get_type(var) == ALPHA ) 
-	memset(val->s, ' ', psppire_variable_get_width(var));
+	if ( data_sheet->state == GTK_SHEET_ROW_SELECTED )
+	  psppire_case_file_delete_cases(data_store->case_file,
+				       data_sheet->range.rowi 
+					 - data_sheet->range.row0 + 1,
+				       data_sheet->range.row0);
       else
-	val->f = SYSMIS;
-
-      case_unshare(cc);
+	  {
+	    gtk_sheet_cell_clear(data_sheet, 
+				 data_sheet->active_cell.row,
+				 data_sheet->active_cell.col);
     }
-
-  return TRUE;
+      }
+      break;
 }
 
+}
 
 void
 on_insert1_activate                    (GtkMenuItem     *menuitem,
@@ -601,15 +580,22 @@ static GtkNotebook *notebook = 0;
 static void
 switch_menus(gint page)
 {
+  GtkWidget *insert_variable = get_widget_assert(xml, "insert-variable");
+  GtkWidget *insert_cases = get_widget_assert(xml, "insert-cases");
+
   switch (page) 
     {
     case PAGE_VAR_SHEET:
       gtk_widget_hide(menuitems[PAGE_VAR_SHEET]);
       gtk_widget_show(menuitems[PAGE_DATA_SHEET]);
+      gtk_widget_set_sensitive(insert_variable, TRUE);
+      gtk_widget_set_sensitive(insert_cases, FALSE);
       break;
     case PAGE_DATA_SHEET:
       gtk_widget_show(menuitems[PAGE_VAR_SHEET]);
       gtk_widget_hide(menuitems[PAGE_DATA_SHEET]);
+      gtk_widget_set_sensitive(insert_variable, FALSE);
+      gtk_widget_set_sensitive(insert_cases, TRUE);
       break;
     default:
       g_assert_not_reached();
@@ -736,3 +722,44 @@ on_sort_cases_activate (GtkMenuItem     
       break;
     }
 }
+
+
+static void 
+insert_case(void)
+{
+  gint row, col;
+  PsppireDataStore *data_store ;
+  GtkSheet *data_sheet = GTK_SHEET(get_widget_assert(xml, "data_sheet"));
+
+  data_store = PSPPIRE_DATA_STORE(gtk_sheet_get_model(data_sheet));
+
+  gtk_sheet_get_active_cell(data_sheet, &row, &col);
+
+  psppire_case_file_insert_case(data_store->case_file, row);
+}
+
+void
+on_insert_case_clicked (GtkButton *button, gpointer user_data)      
+{
+  insert_case();
+}
+
+void
+on_insert_cases (GtkMenuItem *menuitem, gpointer user_data)
+{
+  insert_case();
+}
+
+
+void
+on_insert_variable (GtkMenuItem *menuitem, gpointer user_data)
+{
+  gint row, col;
+  GtkSheet *var_sheet = GTK_SHEET(get_widget_assert(xml, "variable_sheet"));
+
+  gtk_sheet_get_active_cell(var_sheet, &row, &col);
+
+  psppire_dict_insert_variable(the_dictionary, row, NULL);
+}
+
+
Index: src/ui/gui/psppire-case-file.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/ui/gui/psppire-case-file.c,v
retrieving revision 1.2
diff -u -p -r1.2 psppire-case-file.c
--- src/ui/gui/psppire-case-file.c	24 Jun 2006 09:08:50 -0000	1.2
+++ src/ui/gui/psppire-case-file.c	13 Jul 2006 05:27:08 -0000
@@ -28,10 +28,11 @@
 #include <gtksheet/gtkextra-marshal.h>
 
 #include <data/case.h>
+#include <data/flexifile.h>
 #include <data/casefile.h>
 #include <data/data-in.h>
-
 #include <math/sort.h>
+#include <libpspp/misc.h>
 
 /* --- prototypes --- */
 static void psppire_case_file_class_init	(PsppireCaseFileClass	*class);
@@ -132,8 +133,8 @@ psppire_case_file_finalize (GObject *obj
 {
   PsppireCaseFile *cf = PSPPIRE_CASE_FILE (object);
   
-  if ( cf->casefile) 
-    casefile_destroy(cf->casefile);
+  if ( cf->flexifile) 
+    casefile_destroy(cf->flexifile);
 
   G_OBJECT_CLASS (parent_class)->finalize (object);
 }
@@ -141,7 +142,7 @@ psppire_case_file_finalize (GObject *obj
 static void
 psppire_case_file_init (PsppireCaseFile *cf)
 {
-  cf->casefile = 0;
+  cf->flexifile = 0;
 }
 
 /**
@@ -151,16 +152,55 @@ psppire_case_file_init (PsppireCaseFile 
  * Creates a new #PsppireCaseFile. 
  */
 PsppireCaseFile*
-psppire_case_file_new (gint var_cnt)
+psppire_case_file_new (gint val_cnt)
 {
   PsppireCaseFile *cf = g_object_new (G_TYPE_PSPPIRE_CASE_FILE, NULL);
 
-  cf->casefile = casefile_create(var_cnt);
+  cf->flexifile = flexifile_create(val_cnt);
 
   return cf;
 }
 
 
+gboolean
+psppire_case_file_delete_cases(PsppireCaseFile *cf, gint n_cases, gint first)
+{
+  int result;
+
+  g_return_val_if_fail(cf, FALSE);
+  g_return_val_if_fail(cf->flexifile, FALSE);
+
+  result =  flexifile_delete_cases(FLEXIFILE(cf->flexifile), n_cases,  first);
+
+  g_signal_emit(cf, signal[CASES_DELETED], 0, n_cases, first);
+
+  return result;
+}
+
+/* Insert a blank case to the case file */
+gboolean
+psppire_case_file_insert_case(PsppireCaseFile *cf, 
+			       gint posn)
+{
+  bool result ;
+  struct ccase cc;
+
+  g_return_val_if_fail(cf, FALSE);
+  g_return_val_if_fail(cf->flexifile, FALSE);
+
+  case_create (&cc, casefile_get_value_cnt(cf->flexifile));
+
+  result = flexifile_insert_case(FLEXIFILE(cf->flexifile), &cc, posn);
+  
+  case_destroy (&cc);
+
+  if ( result ) 
+    g_signal_emit(cf, signal[CASE_INSERTED], 0, posn);
+  else
+    g_warning("Cannot insert case at position %d\n", posn);
+		
+  return result;
+}
 
 /* Append a case to the case file */
 gboolean
@@ -171,11 +211,11 @@ psppire_case_file_append_case(PsppireCas
   gint posn ;
 
   g_return_val_if_fail(cf, FALSE);
-  g_return_val_if_fail(cf->casefile, FALSE);
+  g_return_val_if_fail(cf->flexifile, FALSE);
 
-  posn = casefile_get_case_cnt(cf->casefile);
+  posn = casefile_get_case_cnt(cf->flexifile);
 
-  result = casefile_append(cf->casefile, c);
+  result = casefile_append(cf->flexifile, c);
   
   g_signal_emit(cf, signal[CASE_INSERTED], 0, posn);
 		
@@ -188,10 +228,10 @@ psppire_case_file_get_case_count(const P
 {
   g_return_val_if_fail(cf, FALSE);
   
-  if ( ! cf->casefile) 
+  if ( ! cf->flexifile) 
     return 0;
 
-  return casefile_get_case_cnt(cf->casefile);
+  return casefile_get_case_cnt(cf->flexifile);
 }
 
 /* Return the IDXth value from case CASENUM.
@@ -202,14 +242,16 @@ psppire_case_file_get_value(const Psppir
 {
   const union value *v; 
   struct ccase c;
-  struct casereader *reader =  casefile_get_random_reader (cf->casefile);
 
-  casereader_seek(reader, casenum);
+  g_return_val_if_fail(cf, NULL);
+  g_return_val_if_fail(cf->flexifile, NULL);
+
+  g_return_val_if_fail(idx < casefile_get_value_cnt(cf->flexifile), NULL);
 
-  casereader_read(reader, &c);
+  flexifile_get_case(FLEXIFILE(cf->flexifile), casenum, &c);
 
   v = case_data(&c, idx);
-  casereader_destroy(reader);
+
   case_destroy(&c);
 
   return v;
@@ -218,22 +260,56 @@ psppire_case_file_get_value(const Psppir
 void
 psppire_case_file_clear(PsppireCaseFile *cf)
 {
-  casefile_destroy(cf->casefile);
-  cf->casefile = 0;
+  casefile_destroy(cf->flexifile);
+  cf->flexifile = 0;
   g_signal_emit(cf, signal[CASES_DELETED], 0, 0, -1);
 }
 
-/* Set the IDXth value of case C using FF and DATA */
+/* Set the IDXth value of case C to SYSMIS/EMPTY */
 gboolean
 psppire_case_file_set_value(PsppireCaseFile *cf, gint casenum, gint idx,
+			    union value *v, gint width)
+{
+  struct ccase cc ;
+  int bytes;
+
+  g_return_val_if_fail(cf, FALSE);
+  g_return_val_if_fail(cf->flexifile, FALSE);
+
+  g_return_val_if_fail(idx < casefile_get_value_cnt(cf->flexifile), FALSE);
+
+  if ( ! flexifile_get_case(FLEXIFILE(cf->flexifile), casenum, &cc) )
+    return FALSE;
+
+  if ( width == 0 ) 
+    bytes = MAX_SHORT_STRING;
+  else
+    bytes = DIV_RND_UP(width, MAX_SHORT_STRING) * MAX_SHORT_STRING ;
+
+  /* Cast away const in flagrant abuse of the casefile */
+  memcpy((union value *)case_data(&cc, idx), v, bytes);
+
+  g_signal_emit(cf, signal[CASE_CHANGED], 0, casenum);
+
+  return TRUE;
+}
+
+
+
+/* Set the IDXth value of case C using D_IN */
+gboolean
+psppire_case_file_data_in(PsppireCaseFile *cf, gint casenum, gint idx,
 			    struct data_in *d_in)
 {
   struct ccase cc ;
 
-  struct casereader *reader =  casefile_get_random_reader (cf->casefile);
+  g_return_val_if_fail(cf, FALSE);
+  g_return_val_if_fail(cf->flexifile, FALSE);
+
+  g_return_val_if_fail(idx < casefile_get_value_cnt(cf->flexifile), FALSE);
 
-  casereader_seek(reader, casenum);
-  casereader_read(reader, &cc);
+  if ( ! flexifile_get_case(FLEXIFILE(cf->flexifile), casenum, &cc) )
+    return FALSE;
 
   /* Cast away const in flagrant abuse of the casefile */
   d_in->v = (union value *) case_data(&cc, idx);
@@ -241,9 +317,6 @@ psppire_case_file_set_value(PsppireCaseF
   if ( ! data_in(d_in) ) 
     g_warning("Cant set value\n");
 
-  case_destroy(&cc);
-  casereader_destroy(reader);
-
   g_signal_emit(cf, signal[CASE_CHANGED], 0, casenum);
 
   return TRUE;
@@ -253,12 +326,45 @@ psppire_case_file_set_value(PsppireCaseF
 void
 psppire_case_file_sort(PsppireCaseFile *cf, const struct sort_criteria *sc)
 {
+  struct ccase cc;
   gint c;
-  struct casereader *reader = casefile_get_reader(cf->casefile);
-  cf->casefile = sort_execute(reader, sc);
+  struct casefile *cfile;
+  struct casereader *reader = casefile_get_reader(cf->flexifile);
+  const int value_cnt = casefile_get_value_cnt(cf->flexifile);
+
+  cfile = sort_execute(reader, sc);
+
+  casefile_destroy(cf->flexifile);
+
+  /* Copy casefile into flexifile */
+
+  reader = casefile_get_destructive_reader(cfile);
+  cf->flexifile = flexifile_create(value_cnt);
+  while(casereader_read(reader, &cc))
+      casefile_append(cf->flexifile, &cc);
+  
 
   /* FIXME: Need to have a signal to change a range of cases, instead of
      calling a signal many times */
-  for ( c = 0 ; c < casefile_get_case_cnt(cf->casefile) ; ++c ) 
+  for ( c = 0 ; c < casefile_get_case_cnt(cf->flexifile) ; ++c ) 
     g_signal_emit(cf, signal[CASE_CHANGED], 0, c);
 }
+
+
+/* Resize the cases in the casefile, by inserting N_VALUES into every 
+   one of them. */
+gboolean 
+psppire_case_file_insert_values(PsppireCaseFile *cf, 
+				gint n_values, gint before)
+{
+  g_return_val_if_fail(cf, FALSE);
+
+  if ( ! cf->flexifile ) 
+    {
+      cf->flexifile = flexifile_create(n_values);
+      return TRUE;
+    }
+
+  return flexifile_resize(FLEXIFILE(cf->flexifile), n_values, before);
+}
+
